The SJS.AI.TRANSLATE function translate an array based on a specified language. For example:
Argument
Required
Description
array
Y
The array, or range to translate
language
Y
The specified language
The SJS.AI.QUERY function allows to query result from AI model with given value. For example:
Argument
Required
Description
prompt
Y
The action that you want AI model to do.
array
Y
The array, or range that you want apply the action
The SJS.AI.TEXTSENTIMENT function Returns the sentiment of text as Positive, Negative, or Neutral. For example:
Argument
Required
Description
array
Y
The array, or range to analyze
positive
Y
The return value if the text sentiment is Positive
negative
Y
The return value if the text sentiment is Negative
neutral
N
The return value if the text sentiment is Neutral
Note:
The AI functions is only valid when allowDynamicArray is true.
AI-Generated Content Disclaimer
1. Content Generation Risks
This service utilizes third-party AI models injected by users to generate outputs. Results may contain inaccuracies, omissions,或 misleading content due to inherent limitations in model architectures and training data. While we implement prompt engineering and technical constraints to optimize outputs, we cannot eliminate all error risks stemming from fundamental model deficiencies.
2. User Verification Obligations
By using this service, you acknowledge and agree to:
Conduct manual verification of all generated content
Refrain from using unvalidated outputs in high-risk scenarios (legal, medical, financial, etc.)
Hold us harmless for any direct/indirect damages caused by reliance on generated content
3. Technical Limitations
We disclaim responsibility for:
Output failures caused by third-party model defects or logic errors
Unsuccessful error recovery attempts through fault-tolerant procedures
Technical constraints inherent in current AI technologies
4. Intellectual Property Compliance
You must ensure:
Injected models/content do not infringe third-party rights
No illegal/sensitive material is processed through the service
Compliance with model providers' IP agreements
5. Agreement Updates
We reserve the right to modify these terms to align with:
Technological advancements (e.g. new AI safety protocols)
Regulatory changes (e.g. updated AI governance frameworks)
Service architecture improvements
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(_getElementById("ss"));
injectAI(spread);
initSpread(spread);
};
function initSpread(spread) {
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
const restaurantReviews = [
["Username", "Review"],
[
"Miss Zhang",
"The restaurant offers a beautiful ambiance and attentive service, perfect for family gatherings.",
],
[
"Mr. Li",
"The food is delicious, but the prices are slightly high, which affects the overall value.",
],
[
"Mr. Wang",
"It was noisy with poor service and slow food delivery, making for a disappointing experience.",
],
[
"Emily",
"Loved the unique dishes and inviting atmosphere! Definitely planning to come back.",
],
[
"Ms. Chen",
"Great flavors and a cozy setting, although the waiting time was a bit too long.",
],
[
"Mr. Zhao",
"A varied menu with mixed results; some dishes were outstanding while others were just average.",
],
[
"George",
"The service was extremely poor and the food quality subpar, leaving a very negative impression.",
],
[
"Miss Liu",
"The food was ordinary and the restaurant was too noisy, which detracted from the overall experience.",
],
];
sheet.setArray(0, 0, restaurantReviews);
sheet.setColumnWidth(0, 85)
sheet.setColumnWidth(1, 560);
sheet.setValue(0, 3, "TEXTSENTIMENT");
sheet.setFormula(
1,
3,
'=SJS.AI.TEXTSENTIMENT(B2:B9, "Positive", "Negative")'
);
sheet.setFormula(0, 5, '=SJS.AI.TRANSLATE(A1:B9, "ja-jp")');
sheet.setColumnWidth(6, 180);
const countries = [
["Country", "Please give me the capital of the country"],
["China"],
["India"],
["United States"],
["Indonesia"],
["Pakistan"],
["Brazil"],
["Nigeria"],
["Bangladesh"],
["Russia"],
["Japan"],
];
sheet.setArray(10, 0, countries);
sheet.setFormula(11, 1, "=SJS.AI.QUERY(B11, A12:A21)");
spread.resumeCalcService();
spread.resumePaint();
}
function _getElementById(id) {
return document.getElementById(id);
}
function injectAI(spread) {
const serverCallback = async (requestBody) => {
const response = await fetch(getAIApiUrl(), {
method: 'POST',
headers: { 'Content-Type': 'application/json' },
body: JSON.stringify(requestBody)
});
if (response.status === 429) {
alert('The server is busy, please try again later.');
return;
}
if (!response.ok) {
throw new Error(`HTTP error! status: ${response.status}`);
}
return response;
};
spread.injectAI(serverCallback);
}
function getAIApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api/queryAI';
}
<!DOCTYPE html>
<html style="height: 100%; font-size: 14px">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link
rel="stylesheet"
type="text/css"
href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"
/>
<script
src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js"
type="text/javascript"
></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-ai-addon/dist/gc.spread.sheets.ai.min.js" type="text/javascript"></script>
<script
src="$DEMOROOT$/spread/source/js/license.js"
type="text/javascript"
></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
margin-bottom: 5px;
padding: 2px 4px;
width: 100%;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

Open the demo in new window can open the designer
The SJS.AI.TRANSLATE function translate an array based on a specified language. For example:
Argument
Required
Description
array
Y
The array, or range to translate
language
Y
The specified language
The SJS.AI.QUERY function allows to query result from AI model with given value. For example:
Argument
Required
Description
prompt
Y
The action that you want AI model to do.
array
Y
The array, or range that you want apply the action
The SJS.AI.TEXTSENTIMENT function Returns the sentiment of text as Positive, Negative, or Neutral. For example:
Argument
Required
Description
array
Y
The array, or range to analyze
positive
Y
The return value if the text sentiment is Positive
negative
Y
The return value if the text sentiment is Negative
neutral
N
The return value if the text sentiment is Neutral
AI-Generated Content Disclaimer
1. Content Generation Risks
This service utilizes third-party AI models injected by users to generate outputs. Results may contain inaccuracies, omissions,或 misleading content due to inherent limitations in model architectures and training data. While we implement prompt engineering and technical constraints to optimize outputs, we cannot eliminate all error risks stemming from fundamental model deficiencies.
2. User Verification Obligations
By using this service, you acknowledge and agree to:
Conduct manual verification of all generated content
Refrain from using unvalidated outputs in high-risk scenarios (legal, medical, financial, etc.)
Hold us harmless for any direct/indirect damages caused by reliance on generated content
3. Technical Limitations
We disclaim responsibility for:
Output failures caused by third-party model defects or logic errors
Unsuccessful error recovery attempts through fault-tolerant procedures
Technical constraints inherent in current AI technologies
4. Intellectual Property Compliance
You must ensure:
Injected models/content do not infringe third-party rights
No illegal/sensitive material is processed through the service
Compliance with model providers' IP agreements
5. Agreement Updates
We reserve the right to modify these terms to align with:
Technological advancements (e.g. new AI safety protocols)
Regulatory changes (e.g. updated AI governance frameworks)
Service architecture improvements
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
createRoot(document.getElementById('app')).render(<AppFunc />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-pivot-addon";
import "@mescius/spread-sheets-tablesheet";
import "@mescius/spread-sheets-io";
import "@mescius/spread-sheets-formula-panel";
import "@mescius/spread-sheets-ai-addon";
import "@mescius/spread-sheets-designer-resources-en";
GC.Spread.Common.CultureManager.culture("en-us");
import { SpreadSheets } from '@mescius/spread-sheets-react';
import { Designer } from "@mescius/spread-sheets-designer-react";
import '$DEMOROOT$/spread/source/js/react_vue/license.js';
import { registerlic } from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js';
registerlic(GC);
const config = GC.Spread.Sheets.Designer.DefaultConfig;
const getAIApiUrl = () => {
return (
window.location.href.match(/http.+spreadjs\/demos\//)[0] +
"server/api/queryAI"
);
};
function injectAI(spread) {
const serverCallback = async (requestBody) => {
const response = await fetch(getAIApiUrl(), {
method: 'POST',
headers: { 'Content-Type': 'application/json' },
body: JSON.stringify(requestBody)
});
if (response.status === 429) {
alert('The server is busy, please try again later.');
return;
}
if (!response.ok) {
throw new Error(`HTTP error! status: ${response.status}`);
}
return response;
};
spread.injectAI(serverCallback);
}
const initSpread = (spread) => {
injectAI(spread);
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
const restaurantReviews = [
["Username", "Review"],
[
"Sophie Martin",
"The restaurant offers a beautiful ambiance and attentive service, perfect for family gatherings.",
],
[
"Carlos Rodríguez",
"The food is delicious, but the prices are slightly high, which affects the overall value.",
],
[
"Ahmed Al-Farsi",
"It was noisy with poor service and slow food delivery, making for a disappointing experience.",
],
[
"Miaki Tanaka",
"Loved the unique dishes and inviting atmosphere!Definitely planning to come back.",
],
[
"Anya Petrovna",
"Great flavors and a cozy setting, although the waiting time was a bit too long.",
],
[
"Rajiv Kapoor",
"A varied menu with mixed results; some dishes were outstanding while others were just average.",
],
[
"Mohammed Hassan",
"The service was extremely poor and the food quality subpar, leaving a very negative impression.",
],
[
"Emma Johnson",
"The food was ordinary and the restaurant was too noisy, which detracted from the overall experience.",
],
];
sheet.setArray(0, 0, restaurantReviews);
sheet.setColumnWidth(0, 95)
sheet.setColumnWidth(1, 700);
sheet.setColumnWidth(2, 160);
sheet.setColumnWidth(3, 480);
sheet.setValue(0, 2, "TEXTSENTIMENT");
sheet.setFormula(1, 2, '=SJS.AI.TEXTSENTIMENT(B2:B9, "Positive", "Negative", "Neutral")');
sheet.getRange("C2:C9").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
sheet.setFormula(0, 3, '="The Formula Is " & FORMULATEXT(C2)');
sheet.setFormula(11, 0, '="The Formula Is " & FORMULATEXT(A13)');
sheet.setFormula(12, 0, '=SJS.AI.TRANSLATE(A1:B9, "ja-jp")');
sheet.getRange("A13:B21").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
const countries = [
["Country", "Please give me the capital of the country"],
["China"],
["India"],
["United States"],
["Indonesia"],
["Pakistan"],
["Brazil"],
["Nigeria"],
["Bangladesh"],
["Russia"],
["Japan"],
];
sheet.setFormula(23, 0, '="The Formula Is " & FORMULATEXT(B26)');
sheet.setArray(24, 0, countries);
sheet.setFormula(25, 1, "=SJS.AI.QUERY(B25, A26:A35)");
sheet.getRange("B26:B35").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
sheet.setFormula(36,1,'="Review Response, The formula is:"&FORMULATEXT(B38)');
sheet.setFormula(37, 1, '=SJS.AI.QUERY("write a friendly one sentence response to the customer\'s review and make sure to acknowledge their specific content",B2:B9)');
sheet.getRange("B38:B45").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
spread.resumeCalcService();
spread.resumePaint();
};
const initDesigner = (designer) => {
initSpread(designer.getWorkbook());
};
export function AppFunc() {
return (
<div class="sample-tutorial">
{top === window ?
<Designer
styleInfo={{ height: "100%", width: "100%" }}
designerInitialized={initDesigner}
/>
:
<React.Fragment>
<div id='demo-host'>
<SpreadSheets workbookInitialized={initSpread} />
</div>
</React.Fragment>
}
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.light.min.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-tutorial {
position: relative;
height: 99vh;
overflow: hidden;
display: flex;
flex-direction: row;
}
#demo-host {
width: 100%;
height: 100%;
flex-grow: 1;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-excelio': 'npm:@mescius/spread-excelio/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-ai-addon': 'npm:@mescius/spread-sheets-ai-addon/index.js',
'@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js',
'@mescius/spread-sheets-designer-react': 'npm:@mescius/spread-sheets-designer-react/index.js',
'@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Open the demo in new window can open the designer
The SJS.AI.TRANSLATE function translate an array based on a specified language. For example:
Argument
Required
Description
array
Y
The array, or range to translate
language
Y
The specified language
The SJS.AI.QUERY function allows to query result from AI model with given value. For example:
Argument
Required
Description
prompt
Y
The action that you want AI model to do.
array
Y
The array, or range that you want apply the action
The SJS.AI.TEXTSENTIMENT function Returns the sentiment of text as Positive, Negative, or Neutral. For example:
Argument
Required
Description
array
Y
The array, or range to analyze
positive
Y
The return value if the text sentiment is Positive
negative
Y
The return value if the text sentiment is Negative
neutral
N
The return value if the text sentiment is Neutral
AI-Generated Content Disclaimer
1. Content Generation Risks
This service utilizes third-party AI models injected by users to generate outputs. Results may contain inaccuracies, omissions,或 misleading content due to inherent limitations in model architectures and training data. While we implement prompt engineering and technical constraints to optimize outputs, we cannot eliminate all error risks stemming from fundamental model deficiencies.
2. User Verification Obligations
By using this service, you acknowledge and agree to:
Conduct manual verification of all generated content
Refrain from using unvalidated outputs in high-risk scenarios (legal, medical, financial, etc.)
Hold us harmless for any direct/indirect damages caused by reliance on generated content
3. Technical Limitations
We disclaim responsibility for:
Output failures caused by third-party model defects or logic errors
Unsuccessful error recovery attempts through fault-tolerant procedures
Technical constraints inherent in current AI technologies
4. Intellectual Property Compliance
You must ensure:
Injected models/content do not infringe third-party rights
No illegal/sensitive material is processed through the service
Compliance with model providers' IP agreements
5. Agreement Updates
We reserve the right to modify these terms to align with:
Technological advancements (e.g. new AI safety protocols)
Regulatory changes (e.g. updated AI governance frameworks)
Service architecture improvements
<template>
<gc-spread-sheets-designer class="demo" v-if="showDesigner" @designerInitialized="initDesigner" />
<div class="sample-tutorial" v-else>
<gc-spread-sheets id="demo-host" @workbookInitialized="initSpread" />
</div>
</template>
<script setup>
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-print';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-charts';
import "@mescius/spread-sheets-pivot-addon";
import '@mescius/spread-sheets-formula-panel';
import "@mescius/spread-sheets-ai-addon";
import '@mescius/spread-sheets-vue';
import '@mescius/spread-sheets-designer-resources-en';
import '@mescius/spread-sheets-designer-vue';
import '$DEMOROOT$/spread/source/js/react_vue/license.js';
import { registerlic } from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js'
registerlic(GC);
GC.Spread.Common.CultureManager.culture("en-us");
const showDesigner = top === window;
const getAIApiUrl = () => {
return (
window.location.href.match(/http.+spreadjs\/demos\//)[0] +
"server/api/queryAI"
);
};
function injectAI(spread) {
const serverCallback = async (requestBody) => {
const response = await fetch(getAIApiUrl(), {
method: 'POST',
headers: { 'Content-Type': 'application/json' },
body: JSON.stringify(requestBody)
});
if (response.status === 429) {
alert('The server is busy, please try again later.');
return;
}
if (!response.ok) {
throw new Error(`HTTP error! status: ${response.status}`);
}
return response;
};
spread.injectAI(serverCallback);
}
function initSpread(spread) {
injectAI(spread);
spread.options.allowDynamicArray = true;
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
const restaurantReviews = [
["Username", "Review"],
[
"Sophie Martin",
"The restaurant offers a beautiful ambiance and attentive service, perfect for family gatherings.",
],
[
"Carlos Rodríguez",
"The food is delicious, but the prices are slightly high, which affects the overall value.",
],
[
"Ahmed Al-Farsi",
"It was noisy with poor service and slow food delivery, making for a disappointing experience.",
],
[
"Miaki Tanaka",
"Loved the unique dishes and inviting atmosphere!Definitely planning to come back.",
],
[
"Anya Petrovna",
"Great flavors and a cozy setting, although the waiting time was a bit too long.",
],
[
"Rajiv Kapoor",
"A varied menu with mixed results; some dishes were outstanding while others were just average.",
],
[
"Mohammed Hassan",
"The service was extremely poor and the food quality subpar, leaving a very negative impression.",
],
[
"Emma Johnson",
"The food was ordinary and the restaurant was too noisy, which detracted from the overall experience.",
],
];
sheet.setArray(0, 0, restaurantReviews);
sheet.setColumnWidth(0, 95);
sheet.setColumnWidth(1, 700);
sheet.setColumnWidth(2, 160);
sheet.setColumnWidth(3, 480);
sheet.setValue(0, 2, "TEXTSENTIMENT");
sheet.setFormula(1, 2, '=SJS.AI.TEXTSENTIMENT(B2:B9, "Positive", "Negative", "Neutral")');
sheet.getRange("C2:C9").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
sheet.setFormula(0, 3, '="The Formula Is " & FORMULATEXT(C2)');
sheet.setFormula(11, 0, '="The Formula Is " & FORMULATEXT(A13)');
sheet.setFormula(12, 0, '=SJS.AI.TRANSLATE(A1:B9, "ja-jp")');
sheet.getRange("A13:B21").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true })
const countries = [
["Country", "Please give me the capital of the country"],
["China"],
["India"],
["United States"],
["Indonesia"],
["Pakistan"],
["Brazil"],
["Nigeria"],
["Bangladesh"],
["Russia"],
["Japan"],
];
sheet.setFormula(23, 0, '="The Formula Is " & FORMULATEXT(B26)');
sheet.setArray(24, 0, countries);
sheet.setFormula(25, 1, "=SJS.AI.QUERY(B25, A26:A35)");
sheet.getRange("B26:B35").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true })
sheet.setFormula(36,1,'="Review Response, The formula is:"&FORMULATEXT(B38)');
sheet.setFormula(37, 1, '=SJS.AI.QUERY("write a friendly one sentence response to the customer\'s review and make sure to acknowledge their specific content",B2:B9)');
sheet.getRange("B38:B45").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true })
spread.resumeCalcService();
spread.resumePaint();
}
function initDesigner (designer) {
initSpread(designer.getWorkbook());
}
</script>
<style scoped>
#app {
height: 98vh;
}
.demo {
height: 100%;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
display: flex;
flex-direction: row;
}
#demo-host {
width: 100%;
height: 100%;
flex-grow: 1;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.light.min.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-ai-addon': 'npm:@mescius/spread-sheets-ai-addon/index.js',
'@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js',
'@mescius/spread-sheets-designer-vue': 'npm:@mescius/spread-sheets-designer-vue/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Open the demo in new window can open the designer
The SJS.AI.TRANSLATE function translate an array based on a specified language. For example:
Argument
Required
Description
array
Y
The array, or range to translate
language
Y
The specified language
The SJS.AI.QUERY function allows to query result from AI model with given value. For example:
Argument
Required
Description
prompt
Y
The action that you want AI model to do.
array
Y
The array, or range that you want apply the action
The SJS.AI.TEXTSENTIMENT function Returns the sentiment of text as Positive, Negative, or Neutral. For example:
Argument
Required
Description
array
Y
The array, or range to analyze
positive
Y
The return value if the text sentiment is Positive
negative
Y
The return value if the text sentiment is Negative
neutral
N
The return value if the text sentiment is Neutral
AI-Generated Content Disclaimer
1. Content Generation Risks
This service utilizes third-party AI models injected by users to generate outputs. Results may contain inaccuracies, omissions,或 misleading content due to inherent limitations in model architectures and training data. While we implement prompt engineering and technical constraints to optimize outputs, we cannot eliminate all error risks stemming from fundamental model deficiencies.
2. User Verification Obligations
By using this service, you acknowledge and agree to:
Conduct manual verification of all generated content
Refrain from using unvalidated outputs in high-risk scenarios (legal, medical, financial, etc.)
Hold us harmless for any direct/indirect damages caused by reliance on generated content
3. Technical Limitations
We disclaim responsibility for:
Output failures caused by third-party model defects or logic errors
Unsuccessful error recovery attempts through fault-tolerant procedures
Technical constraints inherent in current AI technologies
4. Intellectual Property Compliance
You must ensure:
Injected models/content do not infringe third-party rights
No illegal/sensitive material is processed through the service
Compliance with model providers' IP agreements
5. Agreement Updates
We reserve the right to modify these terms to align with:
Technological advancements (e.g. new AI safety protocols)
Regulatory changes (e.g. updated AI governance frameworks)
Service architecture improvements
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-print';
import '@mescius/spread-sheets-shapes';
import '@mescius/spread-sheets-pivot-addon';
import '@mescius/spread-sheets-tablesheet';
import '@mescius/spread-sheets-io';
import '@mescius/spread-sheets-formula-panel';
import '@mescius/spread-sheets-ai-addon';
import '@mescius/spread-sheets-designer-resources-en';
import '@mescius/spread-sheets-designer';
import { DesignerModule } from '@mescius/spread-sheets-designer-angular';
import './styles.css';
import '$DEMOROOT$/spread/source/js/angular/license.ts';
import { registerlic } from '$DEMOROOT$/spread/source/js/designer/react_vue/license.js';
registerlic(GC);
GC.Spread.Common.CultureManager.culture('en-us');
const spreadNS = GC.Spread.Sheets;
function injectAI(spread) {
const serverCallback = async (requestBody) => {
const response = await fetch(getAIApiUrl(), {
method: 'POST',
headers: { 'Content-Type': 'application/json' },
body: JSON.stringify(requestBody)
});
if (response.status === 429) {
alert('The server is busy, please try again later.');
return;
}
if (!response.ok) {
throw new Error(`HTTP error! status: ${response.status}`);
}
return response;
};
spread.injectAI(serverCallback);
}
function getAIApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api/queryAI';
}
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
showDesigner = top === window;
props = {};
hostStyle: any;
constructor() {
if (!this.showDesigner) {
this.hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
}
}
initDesigner($event: any) {
const designer = $event.designer;
initDesigner(designer);
}
initSpread($event: any) {
initSpread($event.spread);
}
}
function initDesigner(designer: any) {
initSpread(designer.getWorkbook());
designer.refresh();
}
function initSpread(spread: any) {
spread.options.allowDynamicArray = true;
injectAI(spread);
var sheet = spread.getActiveSheet();
spread.suspendPaint();
spread.suspendCalcService();
const restaurantReviews = [
["Username", "Review"],
[
"Sophie Martin",
"The restaurant offers a beautiful ambiance and attentive service, perfect for family gatherings.",
],
[
"Carlos Rodríguez",
"The food is delicious, but the prices are slightly high, which affects the overall value.",
],
[
"Ahmed Al-Farsi",
"It was noisy with poor service and slow food delivery, making for a disappointing experience.",
],
[
"Miaki Tanaka",
"Loved the unique dishes and inviting atmosphere!Definitely planning to come back.",
],
[
"Anya Petrovna",
"Great flavors and a cozy setting, although the waiting time was a bit too long.",
],
[
"Rajiv Kapoor",
"A varied menu with mixed results; some dishes were outstanding while others were just average.",
],
[
"Mohammed Hassan",
"The service was extremely poor and the food quality subpar, leaving a very negative impression.",
],
[
"Emma Johnson",
"The food was ordinary and the restaurant was too noisy, which detracted from the overall experience.",
],
];
sheet.setArray(0, 0, restaurantReviews);
sheet.setColumnWidth(0, 95);
sheet.setColumnWidth(1, 700);
sheet.setColumnWidth(2, 160);
sheet.setColumnWidth(3, 480);
sheet.setValue(0, 2, "TEXTSENTIMENT");
sheet.setFormula(1, 2, '=SJS.AI.TEXTSENTIMENT(B2:B9, "Positive", "Negative", "Neutral")');
sheet.getRange("C2:C9").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
sheet.setFormula(0, 3, '="The Formula Is " & FORMULATEXT(C2)');
sheet.setFormula(11, 0, '="The Formula Is " & FORMULATEXT(A13)');
sheet.setFormula(12, 0, '=SJS.AI.TRANSLATE(A1:B9, "ja-jp")');
sheet.getRange("A13:B21").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true });
const countries = [
["Country", "Please give me the capital of the country"],
["China"],
["India"],
["United States"],
["Indonesia"],
["Pakistan"],
["Brazil"],
["Nigeria"],
["Bangladesh"],
["Russia"],
["Japan"],
];
sheet.setFormula(23, 0, '="The Formula Is " & FORMULATEXT(B26)');
sheet.setArray(24, 0, countries);
sheet.setFormula(25, 1, "=SJS.AI.QUERY(B25, A26:A35)");
sheet.getRange("B26:B35").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true })
sheet.setFormula(36,1,'="Review Response, The formula is:"&FORMULATEXT(B38)');
sheet.setFormula(37, 1, '=SJS.AI.QUERY("write a friendly one sentence response to the customer\'s review and make sure to acknowledge their specific content",B2:B9)');
sheet.getRange("B38:B45").setBorder(new GC.Spread.Sheets.LineBorder('#A825FF', GC.Spread.Sheets.LineStyle.thick), { outline: true })
spread.resumeCalcService();
spread.resumePaint();
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, DesignerModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets-designer/styles/gc.spread.sheets.designer.light.min.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<designer *ngIf="showDesigner" [props]="props" [styleInfo]="{ width: '100%' }"
(designerInitialized)="initDesigner($event)"></designer>
<div id="demo-host" *ngIf="!showDesigner">
<gc-spread-sheets [hostStyle]="hostStyle"
(workbookInitialized)="initSpread($event)"></gc-spread-sheets>
</div>
</div>
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-tutorial {
position: relative;
height: 100%;
width: 100%;
overflow: hidden;
display: flex;
flex-direction: row;
}
#demo-host {
width: 100%;
height: 100%;
}
.gc-designer-container {
height: 100%;
width: 100%;
}
designer {
width: 100%;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib': 'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@mescius/spread-sheets-barcode': 'npm:@mescius/spread-sheets-barcode/index.js',
'@mescius/spread-sheets-charts': 'npm:@mescius/spread-sheets-charts/index.js',
'@mescius/spread-sheets-languagepackages': 'npm:@mescius/spread-sheets-languagepackages/index.js',
'@mescius/spread-sheets-print': 'npm:@mescius/spread-sheets-print/index.js',
'@mescius/spread-sheets-pdf': 'npm:@mescius/spread-sheets-pdf/index.js',
'@mescius/spread-sheets-shapes': 'npm:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-io': 'npm:@mescius/spread-sheets-io/index.js',
'@mescius/spread-sheets-ai-addon': 'npm:@mescius/spread-sheets-ai-addon/index.js',
'@mescius/spread-sheets-slicers': 'npm:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'npm:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-formula-panel': 'npm:@mescius/spread-sheets-formula-panel/index.js',
'@mescius/spread-sheets-designer': 'npm:@mescius/spread-sheets-designer/index.js',
'@mescius/spread-sheets-designer-resources-en': 'npm:@mescius/spread-sheets-designer-resources-en/index.js',
'@mescius/spread-sheets-designer-angular': 'npm:@mescius/spread-sheets-designer-angular/fesm2020/mescius-spread-sheets-designer-angular.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-designer-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);